// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: command/charger/ChargingProfile.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace ChargingProfile {

  /// <summary>Holder for reflection information generated from command/charger/ChargingProfile.proto</summary>
  public static partial class ChargingProfileReflection {

    #region Descriptor
    /// <summary>File descriptor for command/charger/ChargingProfile.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static ChargingProfileReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "CiVjb21tYW5kL2NoYXJnZXIvQ2hhcmdpbmdQcm9maWxlLnByb3RvEhBjaGFy",
            "Z2luZ19wcm9maWxlGh9nb29nbGUvcHJvdG9idWYvdGltZXN0YW1wLnByb3Rv",
            "IqgECg9DaGFyZ2luZ1Byb2ZpbGUSGwoTY2hhcmdpbmdfcHJvZmlsZV9pZBgB",
            "IAEoBRIbCg50cmFuc2FjdGlvbl9pZBgCIAEoBUgAiAEBEhMKC3N0YWNrX2xl",
            "dmVsGAMgASgFEk4KGGNoYXJnaW5nX3Byb2ZpbGVfcHVycG9zZRgEIAEoDjIs",
            "LmNoYXJnaW5nX3Byb2ZpbGUuQ2hhcmdpbmdQcm9maWxlUHVycG9zZVR5cGUS",
            "SAoVY2hhcmdpbmdfcHJvZmlsZV9raW5kGAUgASgOMikuY2hhcmdpbmdfcHJv",
            "ZmlsZS5DaGFyZ2luZ1Byb2ZpbGVLaW5kVHlwZRJCCg9yZWN1cnJlbmN5X2tp",
            "bmQYBiABKA4yJC5jaGFyZ2luZ19wcm9maWxlLlJlY3VycmVuY3lLaW5kVHlw",
            "ZUgBiAEBEjMKCnZhbGlkX2Zyb20YByABKAsyGi5nb29nbGUucHJvdG9idWYu",
            "VGltZXN0YW1wSAKIAQESMQoIdmFsaWRfdG8YCCABKAsyGi5nb29nbGUucHJv",
            "dG9idWYuVGltZXN0YW1wSAOIAQESPQoRY2hhcmdpbmdfc2NoZWR1bGUYCSAB",
            "KAsyIi5jaGFyZ2luZ19wcm9maWxlLkNoYXJnaW5nU2NoZWR1bGVCEQoPX3Ry",
            "YW5zYWN0aW9uX2lkQhIKEF9yZWN1cnJlbmN5X2tpbmRCDQoLX3ZhbGlkX2Zy",
            "b21CCwoJX3ZhbGlkX3RvIsgCChBDaGFyZ2luZ1NjaGVkdWxlEhUKCGR1cmF0",
            "aW9uGAEgASgFSACIAQESNwoOc3RhcnRfc2NoZWR1bGUYAiABKAsyGi5nb29n",
            "bGUucHJvdG9idWYuVGltZXN0YW1wSAGIAQESQgoSY2hhcmdpbmdfcmF0ZV91",
            "bml0GAMgASgOMiYuY2hhcmdpbmdfcHJvZmlsZS5DaGFyZ2luZ1JhdGVVbml0",
            "VHlwZRJKChhjaGFyZ2luZ19zY2hlZHVsZV9wZXJpb2QYBCADKAsyKC5jaGFy",
            "Z2luZ19wcm9maWxlLkNoYXJnaW5nU2NoZWR1bGVQZXJpb2QSHgoRbWluX2No",
            "YXJnaW5nX3JhdGUYBSABKAlIAogBAUILCglfZHVyYXRpb25CEQoPX3N0YXJ0",
            "X3NjaGVkdWxlQhQKEl9taW5fY2hhcmdpbmdfcmF0ZSJrChZDaGFyZ2luZ1Nj",
            "aGVkdWxlUGVyaW9kEhQKDHN0YXJ0X3BlcmlvZBgBIAEoBRINCgVsaW1pdBgC",
            "IAEoCRIaCg1udW1iZXJfcGhhc2VzGAMgASgFSACIAQFCEAoOX251bWJlcl9w",
            "aGFzZXMqYgoaQ2hhcmdpbmdQcm9maWxlUHVycG9zZVR5cGUSHAoYQ0hBUkdF",
            "X1BPSU5UX01BWF9QUk9GSUxFEAASFgoSVFhfREVGQVVMVF9QUk9GSUxFEAES",
            "DgoKVFhfUFJPRklMRRACKkQKF0NoYXJnaW5nUHJvZmlsZUtpbmRUeXBlEgwK",
            "CEFCU09MVVRFEAASDQoJUkVDVVJSSU5HEAESDAoIUkVMQVRJVkUQAiorChJS",
            "ZWN1cnJlbmN5S2luZFR5cGUSCQoFREFJTFkQABIKCgZXRUVLTFkQASokChRD",
            "aGFyZ2luZ1JhdGVVbml0VHlwZRIFCgFXEAASBQoBQRABQo0BCiFjb20uY29k",
            "aWJseS5tb2RlbC5jb21tYW5kLmNoYXJnZXJCFENoYXJnaW5nUHJvZmlsZVBy",
            "b3RvygIhRG9tYWluTW9kZWxcUHJvdG9cQ29tbWFuZFxDaGFyZ2Vy4gItRG9t",
            "YWluTW9kZWxcUHJvdG9cQ29tbWFuZFxDaGFyZ2VyXEdQQk1ldGFkYXRhYgZw",
            "cm90bzM="));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { global::Google.Protobuf.WellKnownTypes.TimestampReflection.Descriptor, },
          new pbr::GeneratedClrTypeInfo(new[] {typeof(global::ChargingProfile.ChargingProfilePurposeType), typeof(global::ChargingProfile.ChargingProfileKindType), typeof(global::ChargingProfile.RecurrencyKindType), typeof(global::ChargingProfile.ChargingRateUnitType), }, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::ChargingProfile.ChargingProfile), global::ChargingProfile.ChargingProfile.Parser, new[]{ "ChargingProfileId", "TransactionId", "StackLevel", "ChargingProfilePurpose", "ChargingProfileKind", "RecurrencyKind", "ValidFrom", "ValidTo", "ChargingSchedule" }, new[]{ "TransactionId", "RecurrencyKind", "ValidFrom", "ValidTo" }, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::ChargingProfile.ChargingSchedule), global::ChargingProfile.ChargingSchedule.Parser, new[]{ "Duration", "StartSchedule", "ChargingRateUnit", "ChargingSchedulePeriod", "MinChargingRate" }, new[]{ "Duration", "StartSchedule", "MinChargingRate" }, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::ChargingProfile.ChargingSchedulePeriod), global::ChargingProfile.ChargingSchedulePeriod.Parser, new[]{ "StartPeriod", "Limit", "NumberPhases" }, new[]{ "NumberPhases" }, null, null, null)
          }));
    }
    #endregion

  }
  #region Enums
  public enum ChargingProfilePurposeType {
    [pbr::OriginalName("CHARGE_POINT_MAX_PROFILE")] ChargePointMaxProfile = 0,
    [pbr::OriginalName("TX_DEFAULT_PROFILE")] TxDefaultProfile = 1,
    [pbr::OriginalName("TX_PROFILE")] TxProfile = 2,
  }

  public enum ChargingProfileKindType {
    [pbr::OriginalName("ABSOLUTE")] Absolute = 0,
    [pbr::OriginalName("RECURRING")] Recurring = 1,
    [pbr::OriginalName("RELATIVE")] Relative = 2,
  }

  public enum RecurrencyKindType {
    [pbr::OriginalName("DAILY")] Daily = 0,
    [pbr::OriginalName("WEEKLY")] Weekly = 1,
  }

  public enum ChargingRateUnitType {
    [pbr::OriginalName("W")] W = 0,
    [pbr::OriginalName("A")] A = 1,
  }

  #endregion

  #region Messages
  public sealed partial class ChargingProfile : pb::IMessage<ChargingProfile>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<ChargingProfile> _parser = new pb::MessageParser<ChargingProfile>(() => new ChargingProfile());
    private pb::UnknownFieldSet _unknownFields;
    private int _hasBits0;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<ChargingProfile> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::ChargingProfile.ChargingProfileReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingProfile() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingProfile(ChargingProfile other) : this() {
      _hasBits0 = other._hasBits0;
      chargingProfileId_ = other.chargingProfileId_;
      transactionId_ = other.transactionId_;
      stackLevel_ = other.stackLevel_;
      chargingProfilePurpose_ = other.chargingProfilePurpose_;
      chargingProfileKind_ = other.chargingProfileKind_;
      recurrencyKind_ = other.recurrencyKind_;
      validFrom_ = other.validFrom_ != null ? other.validFrom_.Clone() : null;
      validTo_ = other.validTo_ != null ? other.validTo_.Clone() : null;
      chargingSchedule_ = other.chargingSchedule_ != null ? other.chargingSchedule_.Clone() : null;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingProfile Clone() {
      return new ChargingProfile(this);
    }

    /// <summary>Field number for the "charging_profile_id" field.</summary>
    public const int ChargingProfileIdFieldNumber = 1;
    private int chargingProfileId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int ChargingProfileId {
      get { return chargingProfileId_; }
      set {
        chargingProfileId_ = value;
      }
    }

    /// <summary>Field number for the "transaction_id" field.</summary>
    public const int TransactionIdFieldNumber = 2;
    private int transactionId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int TransactionId {
      get { if ((_hasBits0 & 1) != 0) { return transactionId_; } else { return 0; } }
      set {
        _hasBits0 |= 1;
        transactionId_ = value;
      }
    }
    /// <summary>Gets whether the "transaction_id" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTransactionId {
      get { return (_hasBits0 & 1) != 0; }
    }
    /// <summary>Clears the value of the "transaction_id" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTransactionId() {
      _hasBits0 &= ~1;
    }

    /// <summary>Field number for the "stack_level" field.</summary>
    public const int StackLevelFieldNumber = 3;
    private int stackLevel_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int StackLevel {
      get { return stackLevel_; }
      set {
        stackLevel_ = value;
      }
    }

    /// <summary>Field number for the "charging_profile_purpose" field.</summary>
    public const int ChargingProfilePurposeFieldNumber = 4;
    private global::ChargingProfile.ChargingProfilePurposeType chargingProfilePurpose_ = global::ChargingProfile.ChargingProfilePurposeType.ChargePointMaxProfile;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::ChargingProfile.ChargingProfilePurposeType ChargingProfilePurpose {
      get { return chargingProfilePurpose_; }
      set {
        chargingProfilePurpose_ = value;
      }
    }

    /// <summary>Field number for the "charging_profile_kind" field.</summary>
    public const int ChargingProfileKindFieldNumber = 5;
    private global::ChargingProfile.ChargingProfileKindType chargingProfileKind_ = global::ChargingProfile.ChargingProfileKindType.Absolute;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::ChargingProfile.ChargingProfileKindType ChargingProfileKind {
      get { return chargingProfileKind_; }
      set {
        chargingProfileKind_ = value;
      }
    }

    /// <summary>Field number for the "recurrency_kind" field.</summary>
    public const int RecurrencyKindFieldNumber = 6;
    private global::ChargingProfile.RecurrencyKindType recurrencyKind_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::ChargingProfile.RecurrencyKindType RecurrencyKind {
      get { if ((_hasBits0 & 2) != 0) { return recurrencyKind_; } else { return global::ChargingProfile.RecurrencyKindType.Daily; } }
      set {
        _hasBits0 |= 2;
        recurrencyKind_ = value;
      }
    }
    /// <summary>Gets whether the "recurrency_kind" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasRecurrencyKind {
      get { return (_hasBits0 & 2) != 0; }
    }
    /// <summary>Clears the value of the "recurrency_kind" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearRecurrencyKind() {
      _hasBits0 &= ~2;
    }

    /// <summary>Field number for the "valid_from" field.</summary>
    public const int ValidFromFieldNumber = 7;
    private global::Google.Protobuf.WellKnownTypes.Timestamp validFrom_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Google.Protobuf.WellKnownTypes.Timestamp ValidFrom {
      get { return validFrom_; }
      set {
        validFrom_ = value;
      }
    }

    /// <summary>Field number for the "valid_to" field.</summary>
    public const int ValidToFieldNumber = 8;
    private global::Google.Protobuf.WellKnownTypes.Timestamp validTo_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Google.Protobuf.WellKnownTypes.Timestamp ValidTo {
      get { return validTo_; }
      set {
        validTo_ = value;
      }
    }

    /// <summary>Field number for the "charging_schedule" field.</summary>
    public const int ChargingScheduleFieldNumber = 9;
    private global::ChargingProfile.ChargingSchedule chargingSchedule_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::ChargingProfile.ChargingSchedule ChargingSchedule {
      get { return chargingSchedule_; }
      set {
        chargingSchedule_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as ChargingProfile);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(ChargingProfile other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (ChargingProfileId != other.ChargingProfileId) return false;
      if (TransactionId != other.TransactionId) return false;
      if (StackLevel != other.StackLevel) return false;
      if (ChargingProfilePurpose != other.ChargingProfilePurpose) return false;
      if (ChargingProfileKind != other.ChargingProfileKind) return false;
      if (RecurrencyKind != other.RecurrencyKind) return false;
      if (!object.Equals(ValidFrom, other.ValidFrom)) return false;
      if (!object.Equals(ValidTo, other.ValidTo)) return false;
      if (!object.Equals(ChargingSchedule, other.ChargingSchedule)) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (ChargingProfileId != 0) hash ^= ChargingProfileId.GetHashCode();
      if (HasTransactionId) hash ^= TransactionId.GetHashCode();
      if (StackLevel != 0) hash ^= StackLevel.GetHashCode();
      if (ChargingProfilePurpose != global::ChargingProfile.ChargingProfilePurposeType.ChargePointMaxProfile) hash ^= ChargingProfilePurpose.GetHashCode();
      if (ChargingProfileKind != global::ChargingProfile.ChargingProfileKindType.Absolute) hash ^= ChargingProfileKind.GetHashCode();
      if (HasRecurrencyKind) hash ^= RecurrencyKind.GetHashCode();
      if (validFrom_ != null) hash ^= ValidFrom.GetHashCode();
      if (validTo_ != null) hash ^= ValidTo.GetHashCode();
      if (chargingSchedule_ != null) hash ^= ChargingSchedule.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (ChargingProfileId != 0) {
        output.WriteRawTag(8);
        output.WriteInt32(ChargingProfileId);
      }
      if (HasTransactionId) {
        output.WriteRawTag(16);
        output.WriteInt32(TransactionId);
      }
      if (StackLevel != 0) {
        output.WriteRawTag(24);
        output.WriteInt32(StackLevel);
      }
      if (ChargingProfilePurpose != global::ChargingProfile.ChargingProfilePurposeType.ChargePointMaxProfile) {
        output.WriteRawTag(32);
        output.WriteEnum((int) ChargingProfilePurpose);
      }
      if (ChargingProfileKind != global::ChargingProfile.ChargingProfileKindType.Absolute) {
        output.WriteRawTag(40);
        output.WriteEnum((int) ChargingProfileKind);
      }
      if (HasRecurrencyKind) {
        output.WriteRawTag(48);
        output.WriteEnum((int) RecurrencyKind);
      }
      if (validFrom_ != null) {
        output.WriteRawTag(58);
        output.WriteMessage(ValidFrom);
      }
      if (validTo_ != null) {
        output.WriteRawTag(66);
        output.WriteMessage(ValidTo);
      }
      if (chargingSchedule_ != null) {
        output.WriteRawTag(74);
        output.WriteMessage(ChargingSchedule);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (ChargingProfileId != 0) {
        output.WriteRawTag(8);
        output.WriteInt32(ChargingProfileId);
      }
      if (HasTransactionId) {
        output.WriteRawTag(16);
        output.WriteInt32(TransactionId);
      }
      if (StackLevel != 0) {
        output.WriteRawTag(24);
        output.WriteInt32(StackLevel);
      }
      if (ChargingProfilePurpose != global::ChargingProfile.ChargingProfilePurposeType.ChargePointMaxProfile) {
        output.WriteRawTag(32);
        output.WriteEnum((int) ChargingProfilePurpose);
      }
      if (ChargingProfileKind != global::ChargingProfile.ChargingProfileKindType.Absolute) {
        output.WriteRawTag(40);
        output.WriteEnum((int) ChargingProfileKind);
      }
      if (HasRecurrencyKind) {
        output.WriteRawTag(48);
        output.WriteEnum((int) RecurrencyKind);
      }
      if (validFrom_ != null) {
        output.WriteRawTag(58);
        output.WriteMessage(ValidFrom);
      }
      if (validTo_ != null) {
        output.WriteRawTag(66);
        output.WriteMessage(ValidTo);
      }
      if (chargingSchedule_ != null) {
        output.WriteRawTag(74);
        output.WriteMessage(ChargingSchedule);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (ChargingProfileId != 0) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(ChargingProfileId);
      }
      if (HasTransactionId) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(TransactionId);
      }
      if (StackLevel != 0) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(StackLevel);
      }
      if (ChargingProfilePurpose != global::ChargingProfile.ChargingProfilePurposeType.ChargePointMaxProfile) {
        size += 1 + pb::CodedOutputStream.ComputeEnumSize((int) ChargingProfilePurpose);
      }
      if (ChargingProfileKind != global::ChargingProfile.ChargingProfileKindType.Absolute) {
        size += 1 + pb::CodedOutputStream.ComputeEnumSize((int) ChargingProfileKind);
      }
      if (HasRecurrencyKind) {
        size += 1 + pb::CodedOutputStream.ComputeEnumSize((int) RecurrencyKind);
      }
      if (validFrom_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(ValidFrom);
      }
      if (validTo_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(ValidTo);
      }
      if (chargingSchedule_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(ChargingSchedule);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(ChargingProfile other) {
      if (other == null) {
        return;
      }
      if (other.ChargingProfileId != 0) {
        ChargingProfileId = other.ChargingProfileId;
      }
      if (other.HasTransactionId) {
        TransactionId = other.TransactionId;
      }
      if (other.StackLevel != 0) {
        StackLevel = other.StackLevel;
      }
      if (other.ChargingProfilePurpose != global::ChargingProfile.ChargingProfilePurposeType.ChargePointMaxProfile) {
        ChargingProfilePurpose = other.ChargingProfilePurpose;
      }
      if (other.ChargingProfileKind != global::ChargingProfile.ChargingProfileKindType.Absolute) {
        ChargingProfileKind = other.ChargingProfileKind;
      }
      if (other.HasRecurrencyKind) {
        RecurrencyKind = other.RecurrencyKind;
      }
      if (other.validFrom_ != null) {
        if (validFrom_ == null) {
          ValidFrom = new global::Google.Protobuf.WellKnownTypes.Timestamp();
        }
        ValidFrom.MergeFrom(other.ValidFrom);
      }
      if (other.validTo_ != null) {
        if (validTo_ == null) {
          ValidTo = new global::Google.Protobuf.WellKnownTypes.Timestamp();
        }
        ValidTo.MergeFrom(other.ValidTo);
      }
      if (other.chargingSchedule_ != null) {
        if (chargingSchedule_ == null) {
          ChargingSchedule = new global::ChargingProfile.ChargingSchedule();
        }
        ChargingSchedule.MergeFrom(other.ChargingSchedule);
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            ChargingProfileId = input.ReadInt32();
            break;
          }
          case 16: {
            TransactionId = input.ReadInt32();
            break;
          }
          case 24: {
            StackLevel = input.ReadInt32();
            break;
          }
          case 32: {
            ChargingProfilePurpose = (global::ChargingProfile.ChargingProfilePurposeType) input.ReadEnum();
            break;
          }
          case 40: {
            ChargingProfileKind = (global::ChargingProfile.ChargingProfileKindType) input.ReadEnum();
            break;
          }
          case 48: {
            RecurrencyKind = (global::ChargingProfile.RecurrencyKindType) input.ReadEnum();
            break;
          }
          case 58: {
            if (validFrom_ == null) {
              ValidFrom = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(ValidFrom);
            break;
          }
          case 66: {
            if (validTo_ == null) {
              ValidTo = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(ValidTo);
            break;
          }
          case 74: {
            if (chargingSchedule_ == null) {
              ChargingSchedule = new global::ChargingProfile.ChargingSchedule();
            }
            input.ReadMessage(ChargingSchedule);
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            ChargingProfileId = input.ReadInt32();
            break;
          }
          case 16: {
            TransactionId = input.ReadInt32();
            break;
          }
          case 24: {
            StackLevel = input.ReadInt32();
            break;
          }
          case 32: {
            ChargingProfilePurpose = (global::ChargingProfile.ChargingProfilePurposeType) input.ReadEnum();
            break;
          }
          case 40: {
            ChargingProfileKind = (global::ChargingProfile.ChargingProfileKindType) input.ReadEnum();
            break;
          }
          case 48: {
            RecurrencyKind = (global::ChargingProfile.RecurrencyKindType) input.ReadEnum();
            break;
          }
          case 58: {
            if (validFrom_ == null) {
              ValidFrom = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(ValidFrom);
            break;
          }
          case 66: {
            if (validTo_ == null) {
              ValidTo = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(ValidTo);
            break;
          }
          case 74: {
            if (chargingSchedule_ == null) {
              ChargingSchedule = new global::ChargingProfile.ChargingSchedule();
            }
            input.ReadMessage(ChargingSchedule);
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class ChargingSchedule : pb::IMessage<ChargingSchedule>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<ChargingSchedule> _parser = new pb::MessageParser<ChargingSchedule>(() => new ChargingSchedule());
    private pb::UnknownFieldSet _unknownFields;
    private int _hasBits0;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<ChargingSchedule> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::ChargingProfile.ChargingProfileReflection.Descriptor.MessageTypes[1]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingSchedule() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingSchedule(ChargingSchedule other) : this() {
      _hasBits0 = other._hasBits0;
      duration_ = other.duration_;
      startSchedule_ = other.startSchedule_ != null ? other.startSchedule_.Clone() : null;
      chargingRateUnit_ = other.chargingRateUnit_;
      chargingSchedulePeriod_ = other.chargingSchedulePeriod_.Clone();
      minChargingRate_ = other.minChargingRate_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingSchedule Clone() {
      return new ChargingSchedule(this);
    }

    /// <summary>Field number for the "duration" field.</summary>
    public const int DurationFieldNumber = 1;
    private int duration_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int Duration {
      get { if ((_hasBits0 & 1) != 0) { return duration_; } else { return 0; } }
      set {
        _hasBits0 |= 1;
        duration_ = value;
      }
    }
    /// <summary>Gets whether the "duration" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasDuration {
      get { return (_hasBits0 & 1) != 0; }
    }
    /// <summary>Clears the value of the "duration" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearDuration() {
      _hasBits0 &= ~1;
    }

    /// <summary>Field number for the "start_schedule" field.</summary>
    public const int StartScheduleFieldNumber = 2;
    private global::Google.Protobuf.WellKnownTypes.Timestamp startSchedule_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Google.Protobuf.WellKnownTypes.Timestamp StartSchedule {
      get { return startSchedule_; }
      set {
        startSchedule_ = value;
      }
    }

    /// <summary>Field number for the "charging_rate_unit" field.</summary>
    public const int ChargingRateUnitFieldNumber = 3;
    private global::ChargingProfile.ChargingRateUnitType chargingRateUnit_ = global::ChargingProfile.ChargingRateUnitType.W;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::ChargingProfile.ChargingRateUnitType ChargingRateUnit {
      get { return chargingRateUnit_; }
      set {
        chargingRateUnit_ = value;
      }
    }

    /// <summary>Field number for the "charging_schedule_period" field.</summary>
    public const int ChargingSchedulePeriodFieldNumber = 4;
    private static readonly pb::FieldCodec<global::ChargingProfile.ChargingSchedulePeriod> _repeated_chargingSchedulePeriod_codec
        = pb::FieldCodec.ForMessage(34, global::ChargingProfile.ChargingSchedulePeriod.Parser);
    private readonly pbc::RepeatedField<global::ChargingProfile.ChargingSchedulePeriod> chargingSchedulePeriod_ = new pbc::RepeatedField<global::ChargingProfile.ChargingSchedulePeriod>();
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public pbc::RepeatedField<global::ChargingProfile.ChargingSchedulePeriod> ChargingSchedulePeriod {
      get { return chargingSchedulePeriod_; }
    }

    /// <summary>Field number for the "min_charging_rate" field.</summary>
    public const int MinChargingRateFieldNumber = 5;
    private string minChargingRate_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string MinChargingRate {
      get { return minChargingRate_ ?? ""; }
      set {
        minChargingRate_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "min_charging_rate" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasMinChargingRate {
      get { return minChargingRate_ != null; }
    }
    /// <summary>Clears the value of the "min_charging_rate" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearMinChargingRate() {
      minChargingRate_ = null;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as ChargingSchedule);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(ChargingSchedule other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (Duration != other.Duration) return false;
      if (!object.Equals(StartSchedule, other.StartSchedule)) return false;
      if (ChargingRateUnit != other.ChargingRateUnit) return false;
      if(!chargingSchedulePeriod_.Equals(other.chargingSchedulePeriod_)) return false;
      if (MinChargingRate != other.MinChargingRate) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (HasDuration) hash ^= Duration.GetHashCode();
      if (startSchedule_ != null) hash ^= StartSchedule.GetHashCode();
      if (ChargingRateUnit != global::ChargingProfile.ChargingRateUnitType.W) hash ^= ChargingRateUnit.GetHashCode();
      hash ^= chargingSchedulePeriod_.GetHashCode();
      if (HasMinChargingRate) hash ^= MinChargingRate.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (HasDuration) {
        output.WriteRawTag(8);
        output.WriteInt32(Duration);
      }
      if (startSchedule_ != null) {
        output.WriteRawTag(18);
        output.WriteMessage(StartSchedule);
      }
      if (ChargingRateUnit != global::ChargingProfile.ChargingRateUnitType.W) {
        output.WriteRawTag(24);
        output.WriteEnum((int) ChargingRateUnit);
      }
      chargingSchedulePeriod_.WriteTo(output, _repeated_chargingSchedulePeriod_codec);
      if (HasMinChargingRate) {
        output.WriteRawTag(42);
        output.WriteString(MinChargingRate);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (HasDuration) {
        output.WriteRawTag(8);
        output.WriteInt32(Duration);
      }
      if (startSchedule_ != null) {
        output.WriteRawTag(18);
        output.WriteMessage(StartSchedule);
      }
      if (ChargingRateUnit != global::ChargingProfile.ChargingRateUnitType.W) {
        output.WriteRawTag(24);
        output.WriteEnum((int) ChargingRateUnit);
      }
      chargingSchedulePeriod_.WriteTo(ref output, _repeated_chargingSchedulePeriod_codec);
      if (HasMinChargingRate) {
        output.WriteRawTag(42);
        output.WriteString(MinChargingRate);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (HasDuration) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(Duration);
      }
      if (startSchedule_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(StartSchedule);
      }
      if (ChargingRateUnit != global::ChargingProfile.ChargingRateUnitType.W) {
        size += 1 + pb::CodedOutputStream.ComputeEnumSize((int) ChargingRateUnit);
      }
      size += chargingSchedulePeriod_.CalculateSize(_repeated_chargingSchedulePeriod_codec);
      if (HasMinChargingRate) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(MinChargingRate);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(ChargingSchedule other) {
      if (other == null) {
        return;
      }
      if (other.HasDuration) {
        Duration = other.Duration;
      }
      if (other.startSchedule_ != null) {
        if (startSchedule_ == null) {
          StartSchedule = new global::Google.Protobuf.WellKnownTypes.Timestamp();
        }
        StartSchedule.MergeFrom(other.StartSchedule);
      }
      if (other.ChargingRateUnit != global::ChargingProfile.ChargingRateUnitType.W) {
        ChargingRateUnit = other.ChargingRateUnit;
      }
      chargingSchedulePeriod_.Add(other.chargingSchedulePeriod_);
      if (other.HasMinChargingRate) {
        MinChargingRate = other.MinChargingRate;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            Duration = input.ReadInt32();
            break;
          }
          case 18: {
            if (startSchedule_ == null) {
              StartSchedule = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(StartSchedule);
            break;
          }
          case 24: {
            ChargingRateUnit = (global::ChargingProfile.ChargingRateUnitType) input.ReadEnum();
            break;
          }
          case 34: {
            chargingSchedulePeriod_.AddEntriesFrom(input, _repeated_chargingSchedulePeriod_codec);
            break;
          }
          case 42: {
            MinChargingRate = input.ReadString();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            Duration = input.ReadInt32();
            break;
          }
          case 18: {
            if (startSchedule_ == null) {
              StartSchedule = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            input.ReadMessage(StartSchedule);
            break;
          }
          case 24: {
            ChargingRateUnit = (global::ChargingProfile.ChargingRateUnitType) input.ReadEnum();
            break;
          }
          case 34: {
            chargingSchedulePeriod_.AddEntriesFrom(ref input, _repeated_chargingSchedulePeriod_codec);
            break;
          }
          case 42: {
            MinChargingRate = input.ReadString();
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class ChargingSchedulePeriod : pb::IMessage<ChargingSchedulePeriod>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<ChargingSchedulePeriod> _parser = new pb::MessageParser<ChargingSchedulePeriod>(() => new ChargingSchedulePeriod());
    private pb::UnknownFieldSet _unknownFields;
    private int _hasBits0;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<ChargingSchedulePeriod> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::ChargingProfile.ChargingProfileReflection.Descriptor.MessageTypes[2]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingSchedulePeriod() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingSchedulePeriod(ChargingSchedulePeriod other) : this() {
      _hasBits0 = other._hasBits0;
      startPeriod_ = other.startPeriod_;
      limit_ = other.limit_;
      numberPhases_ = other.numberPhases_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public ChargingSchedulePeriod Clone() {
      return new ChargingSchedulePeriod(this);
    }

    /// <summary>Field number for the "start_period" field.</summary>
    public const int StartPeriodFieldNumber = 1;
    private int startPeriod_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int StartPeriod {
      get { return startPeriod_; }
      set {
        startPeriod_ = value;
      }
    }

    /// <summary>Field number for the "limit" field.</summary>
    public const int LimitFieldNumber = 2;
    private string limit_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Limit {
      get { return limit_; }
      set {
        limit_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "number_phases" field.</summary>
    public const int NumberPhasesFieldNumber = 3;
    private int numberPhases_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int NumberPhases {
      get { if ((_hasBits0 & 1) != 0) { return numberPhases_; } else { return 0; } }
      set {
        _hasBits0 |= 1;
        numberPhases_ = value;
      }
    }
    /// <summary>Gets whether the "number_phases" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasNumberPhases {
      get { return (_hasBits0 & 1) != 0; }
    }
    /// <summary>Clears the value of the "number_phases" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearNumberPhases() {
      _hasBits0 &= ~1;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as ChargingSchedulePeriod);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(ChargingSchedulePeriod other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (StartPeriod != other.StartPeriod) return false;
      if (Limit != other.Limit) return false;
      if (NumberPhases != other.NumberPhases) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (StartPeriod != 0) hash ^= StartPeriod.GetHashCode();
      if (Limit.Length != 0) hash ^= Limit.GetHashCode();
      if (HasNumberPhases) hash ^= NumberPhases.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (StartPeriod != 0) {
        output.WriteRawTag(8);
        output.WriteInt32(StartPeriod);
      }
      if (Limit.Length != 0) {
        output.WriteRawTag(18);
        output.WriteString(Limit);
      }
      if (HasNumberPhases) {
        output.WriteRawTag(24);
        output.WriteInt32(NumberPhases);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (StartPeriod != 0) {
        output.WriteRawTag(8);
        output.WriteInt32(StartPeriod);
      }
      if (Limit.Length != 0) {
        output.WriteRawTag(18);
        output.WriteString(Limit);
      }
      if (HasNumberPhases) {
        output.WriteRawTag(24);
        output.WriteInt32(NumberPhases);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (StartPeriod != 0) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(StartPeriod);
      }
      if (Limit.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Limit);
      }
      if (HasNumberPhases) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(NumberPhases);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(ChargingSchedulePeriod other) {
      if (other == null) {
        return;
      }
      if (other.StartPeriod != 0) {
        StartPeriod = other.StartPeriod;
      }
      if (other.Limit.Length != 0) {
        Limit = other.Limit;
      }
      if (other.HasNumberPhases) {
        NumberPhases = other.NumberPhases;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            StartPeriod = input.ReadInt32();
            break;
          }
          case 18: {
            Limit = input.ReadString();
            break;
          }
          case 24: {
            NumberPhases = input.ReadInt32();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            StartPeriod = input.ReadInt32();
            break;
          }
          case 18: {
            Limit = input.ReadString();
            break;
          }
          case 24: {
            NumberPhases = input.ReadInt32();
            break;
          }
        }
      }
    }
    #endif

  }

  #endregion

}

#endregion Designer generated code
